from enum import IntEnum

from xync_client.Abc.Base import ListOfDicts, MapOfIdsList
from xync_client.Abc.Ex import BaseExClient


class AdsStatus(IntEnum):
    REST = 0
    WORKING = 1


class ExClient(BaseExClient):  # Bybit client
    host = "api2.bybit.com"
    headers = {"cookie": ";"}  # rewrite token for public methods

    """ PUBLIC METHS """

    async def get_ads(
        self, coin: str, cur: str, sell: bool = False, amount: int = None, payment: list[str] = None
    ) -> list:
        data = {
            "userId": "",
            "tokenId": coin,
            "currencyId": cur,
            "payment": payment or [],
            "side": "0" if sell else "1",
            "size": "10",
            "page": "1",
            "amount": str(amount) if amount else "",
            "authMaker": False,
            "canTrade": False,
        }
        ads = await self._post("/fiat/otc/item/online/", data)
        return ads["result"]["items"]

    async def get_config(self):
        resp = await self._get("/fiat/p2p/config/initial")
        return resp["result"]  # todo: tokens, pairs, ...

    async def curs(self):
        config = await self.get_config()
        return config["symbols"]

    async def coins(self):
        coins = await self._get("/spot/api/basic/symbol_list")
        return coins

    async def pms(self):
        pms = await self._post("/fiat/otc/configuration/queryAllPaymentList/")
        return pms

    """ Private METHs"""

    async def cur_pms_map(self) -> MapOfIdsList:
        pass

    async def ads(self, coin_exid: str, cur_exid: str, is_sell: bool, pm_exids: list[str | int] = None) -> ListOfDicts:
        pass
